## Meros Lysis tis Askisis 38 (me xrisi R + grafimata + sxoliasmos)
# Dedomena Hubble
# Monades Metrisis : X (se Mpc) Y (se km/s) 


## Dedomena
#X 0.032 0.034 0.214 0.263 0.275 0.275 0.45 0.5 0.5 0.63 0.8 0.9
#Y  170 290 -130 -70 -185 -220 200 290 270 200 300 -30

#X  0.9 0.9 0.9 1.0 1.1 1.1 1.4 1.7 2.0 2.0 2.0 2.0
#Y  650 150 500 920 450 500 500 960 500 850 800 1090

#-----------------------------------------------------------------------------------------------------------
## Prota Grafimata
# Sximatizoume ta dianysmata X kai Y  

X=c(0.032, 0.034, 0.214, 0.263, 0.275, 0.275, 0.45, 0.5, 0.5, 0.63, 0.8, 0.9,
    0.9, 0.9, 0.9, 1.0, 1.1, 1.1, 1.4, 1.7, 2.0, 2.0, 2.0, 2.0)

Y=c(170, 290, -130, -70, -185, -220, 200, 290, 270, 200, 300, -30,
    650, 150, 500, 920, 450, 500, 500, 960, 500, 850, 800, 1090)

# Sxediazoume to grafima ton dedomenon kai tin eytheia elaxiston tetragonon

plot(X, Y)

# Sxolio: Parolo pou ta dedomena fainontai arketa diesparmena, diakrinoume mia grammiki tasi anodou tis Y
# kathos i X ayksanei. Mia apli grammiki palindromisi sta dedomena fainetai os logiki epilogi.
# Ayto antistoixei edo sti lysi me ti methodo tis megistis pithanofaneias

mod1 = lm(Y ~ 0 + X) 

# me ti synartisi lm() kanoume ti grammiki palindromisi Y~X opou Y eksartimeni kai X aneksartiti metavliti.
# H prosthiki tou 0 sto (0 + X) statheropoiei ti stathera a=0, sto montelo Y = a + b*X + s*Z,
# opou c i tetagmeni epi tin arxi (intercept), b i klisi tiw eytheias, s i tipiki apoklisi kai Z ~ N(0,1)

# Sxediazoume to grafima ton dedomenon mazi me tin eytheia elaxiston tetragonon me xroma kokkino

plot(X, Y, pch=21, bg="grey", main = "Grammiki Palindromisi sta dedomena tou Hubble", xlab = "Apostasi X tou Nefelomatos apo ti Gi (Mpc)", ylab = "Aktiniki Taxitita Y (km/s)")
abline(mod1, col="red") 

#-------------------------------------------------------------------------------------------------------------
## Erotima (i)
# Gia na doume tis ektimiseis ton parametron pliktrologoume 
summary(mod1)     

# (apomonono ayta pou mas endiaferoun)
# Coefficients:       
#  Estimate Std. Error t value Pr(>|t|)    
# X   423.94      42.15   10.06 6.87e-10 ***
# Residual standard error: 229 on 23 degrees of freedom

#Prosoxi! 
# emp(b) = 423.94   (dinetai sti stili Estimate, emp den einai entoli! 
# Ayti einai kai i ektimisi tou rithmou diastolis tou sympantos.
# epalithevoume me ayto poy vrikame apo ti theoria (mi ksexnate, edo kanoume Mathimatiki Statistiki !!!)
# sum(X*Y)/sum(X*X)  (=423.9373) 
# emp(s^2) = sum((Y-423.9373*X)^2)/length(Y) [= 50266.78= (224.2025)^2 ]
# Paratiriste oti (Residual standard error)^2 = 229^2=52441 diaforetiko apo 50267 pou vrikame !
# Ayto symvainei dioti i typiki apoklisi pou dinetai apo to residual standard error
# sta apotelesmata tis palindromisis anaferetai sti riza tis ameroliptis deigmatikis diasporas kai oxi tis emp.
# epalithevoume loipon, ypologizontas: sqrt(sum((Y-423.94*X)^2)/(length(Y)-1)) (= 229.0246) opos pragmati katagrafetai.

#------------------------------------------------------------------------------------------------------------
## erotima (ii)
# epanalamvanoume ti diadikasia ensomatonontas kai ti stathera a kai prosthetoume tin kainouria eytheia elax. tetragono

mod2 = lm(Y ~ X) 
abline(mod2, col="blue")  

legend("topleft",                           #inset = c(0,0.4), 
        c("Y ~ b*X", "Y ~ a + b*X"),               # gives names to the lines
        lty=c(1,1),                         # gives the legend appropriate symbols (lines)
        lwd=c(2.5,2.5),
        col=c("red","blue"),                 # gives the legend lines the correct color and width    
        text.col = c("red", "blue"))

# Sxolio: Fainetai sxetika mikri i diafora me tin prosthiki tis parametrou a

# Gia na doume tis ektimiseis ton parametron pliktrologoume 
summary(mod2)     

# (apomonono ayta pou mas endiaferoun)
# Coefficients:
#            Estimate Std. Error t value Pr(>|t|)    
# (Intercept)   -40.78      83.44  -0.489     0.63    
# X              454.16      75.24   6.036 4.48e-06 ***
# Residual standard error: 232.9 on 22 degrees of freedom

# emp(a)   =  -40.78
# emp(b)   =  454.16   
# emp(s^2) =  ((length(Y)-2)/length(Y))*(232.9)^2  (=49722). 

# Epalithefste eseis ta apotelesmata ayta apo tous typous pou vrikame sti lysi tis Askisis (erotima ii))

#--------------------------------------------------------------------------------------------------
# Erotima (iii)

AIC(mod1)     # ypologismos tou AIC gia modelo 1
AIC(mod2)     # ypologismos tou AIC gia modelo 2

# Ta apotelesmata einai :
# AIC(mod1) 
# [1] 331.9114
# AIC(mod2)
# [1] 333.6522

# Sxolio: Paratiroyme oti AIC(model1) < AIC(model2), ara to montelo 1 einai kalytero me ayto to kritirio.
# I prosthiki tis parametrou a den veltionei "simantika" tin prosarmogi tou montelou sta dedomena
# kai kalytera na min ensomatothei me ti logiki tis epilogis montelon.

# Mporoyme malista na doume poso veltiothike i logarithmopithanofaneia tou montelou me tin prosthiki tou a
# Me ti sinartisi logLik() exoume tin apotimisi tis stin emp.

# Ta apotelesmata einai:
#> logLik(mod1)
#'log Lik.' -163.9557 (df=2)
#> logLik(mod2)
#'log Lik.' -163.8261 (df=3)

#Vlepoume oti i veltiosi tis logLikelihood apo to montelo 1 sto montelo 2 einai poly mikri kai etsi den tha dikaiologouse tin 
#prosthiki tis parametrou a, opos eksallou apotipothike sto AIC pou vazei poini gia tin prosthiki mias parametrou,
#alla kai grafika afou eidame oti i veltisti eytheia metatopistike elaxista.

